
#include <XBee.h>    //inclui bibliotecas necessarias no projeto
#include <SPI.h>
#include <WiFi.h>
#include <Wire.h>
#include <SeeedOLED.h>

uint8_t option = 0;  //variaveis utilizadas na recepcao de mensagens XBee
uint8_t data = 0;

float Vrms1 = 0 ;  //variaveis para armazenar informacoes do Modulo AC
float Vrms2 = 0 ;
float Vrms3 = 0 ;
float Irms1 = 0 ;
float Irms2 = 0 ;
float Irms3 = 0 ;
float frequenciadaRede = 0;
float temperaturaModuloAC = 0;

char ssid[] = "IoTRoadshow";      // your network SSID (name) 
//char pass[] = "";   // your network password
int keyIndex = 0;                 // your network key Index number (needed only for WEP)
int status = WL_IDLE_STATUS;

WiFiClient client;

char server[] = "data.sparkfun.com";    // name address for data.sparkFun (using DNS)

/////////////////
// Phant Stuff //
/////////////////
const String publicKey = "g6qpyOJDOGSKdGpWQbMV";
const String privateKey = "qzY75PDMPeug2KGwaqAm";
const byte NUM_FIELDS = 7;
const String fieldNames[NUM_FIELDS] = {"v1_rms", "i1_rms", "v2_rms", "i2_rms", "temperature", "frequency","total_power"};
float fieldData[NUM_FIELDS];

XBee xbee = XBee();  //cria objeto XBee para comunicacao com os demais modulos
XBeeResponse response = XBeeResponse();  //cria objetos para recepcao de mensagens
Rx16Response rx16 = Rx16Response();  //cria objeto response do tipo Rx16Response
Rx16IoSampleResponse ioSample = Rx16IoSampleResponse();  //cria objeto response do tipo Rx16IoSampleResponse  

uint8_t atCmd[2];  // cria arrays utilizados no envio de pacotes via XBee
uint8_t atValue[1];
uint8_t payload[2];

// Cria uma remote AT request 
RemoteAtCommandRequest remoteAtRequest = RemoteAtCommandRequest(1, atCmd, atValue, sizeof(atValue));
// Cria uma Remote AT response object
RemoteAtCommandResponse remoteAtResponse = RemoteAtCommandResponse();

// Cria uma remote payload TX request 
Tx16Request tx = Tx16Request(1, payload, sizeof(payload)); 
// Create uma Remote payload response object
TxStatusResponse txStatus = TxStatusResponse();

void setup(){ 

  Serial1.begin(19200);  //porta debug serial monitor
  xbee.setSerial(Serial1);
  
  // Use Serial for printing to the serial monitor
  Serial.begin(9600);  // Use Serial for printing to the serial monitor
  // wait for leonardo Serial
  //  while (!Serial);
  Serial.println("XBee sketch is running!");

  Wire.begin();  //inicializa a interface I2C utilizada na comunicacao com o display OLED 
  SeeedOled.init();  //inicializa o SEEED OLED display
  SeeedOled.clearDisplay();          //clear the screen and set start position to top left corner
  SeeedOled.setNormalDisplay();      //Set display to normal mode (i.e non-inverse mode)
  SeeedOled.setPageMode();           //Set addressing mode to Page Mode
  SeeedOled.setTextXY(0,0);          //Set the cursor to Xth Page, Yth Column  
  SeeedOled.putString("  IoT RoadShow"); //Print the String
  delay(3000);
  
 // Set WIFI:
 
   // check for the presence of the shield:
  if (WiFi.status() == WL_NO_SHIELD) {
    Serial.println("WiFi shield not present"); 
    // don't continue:
    while(true);
  } 

  String fv = WiFi.firmwareVersion();
  if( fv != "1.1.0" )
    Serial.println("Please upgrade the firmware");
  
  // attempt to connect to Wifi network:
  while ( status != WL_CONNECTED) { 
    Serial.print("Attempting to connect to SSID: ");
    Serial.println(ssid);
    // Connect to WPA/WPA2 network. Change this line if using open or WEP network:    
    status = WiFi.begin(ssid);

    // wait 10 seconds for connection:
    delay(10000);
  } 
  // you're connected now, so print out the status:
  printWifiStatus();
}

void loop(){
  XBee_RX();  //chama rotina que verifica pacotes XBee recebidos do modulos remotos  
//  Serial.println("loop");
}
